local AceGUI = LibStub("AceGUI-3.0")

local scrollStatistics = nil;
local historyBtn = nil;
local uniqueDates = nil;
local historyInstance = nil;
local historyDate = nil;
local historyKill = nil;
local sortType = 0;
local alts = {};
local playerForRemove = {};
local startDate = nil;
local startDateText = "";
local stopDate = nil;
local stopDateText = "";
local item1Btn, item2Btn, item3Btn, item4Btn, item5Btn, item6Btn, item7Btn = nil, nil, nil, nil, nil, nil, nil;
local firstIndex = 1;

local statisticsPlayerData = {};
local killsCounts = {};

-- History toggle action
-- =========================
function MorthalinRaidTools:ToggleStatistics()
	if MorthalinRaidTools.ui.statisticsFrame:IsVisible() then
		MorthalinRaidTools.ui.statisticsFrame:Hide();
	else
		MorthalinRaidTools.ui.statisticsFrame:Show();
		MorthalinRaidTools:LoadStatistics();
		MorthalinRaidTools:LoadRaidHeaders();
		self:UpdateStatisticsView(sortType);
	end
end

function MorthalinRaidTools:ConstructStatisticsFrame()
	self.ui.statisticsFrame = AceGUI:Create("Frame");
	self.ui.statisticsFrame:SetTitle("Player Statistics");
	self.ui.statisticsFrame:SetStatusText("");
	self.ui.statisticsFrame:SetLayout("Flow");
	self.ui.statisticsFrame:SetWidth(1150);
	self.ui.statisticsFrame:EnableResize(false);
	self.ui.statisticsFrame.frame:EnableMouse(true);
	self.ui.statisticsFrame.frame:SetUserPlaced(true);
	
	-- CONTROLS HEADER
	local controlsHeader = AceGUI:Create("SimpleGroup");
	controlsHeader:SetFullWidth(true);
	controlsHeader:SetLayout("Flow");
	self.ui.statisticsFrame:AddChild(controlsHeader);
	
	startDate = AceGUI:Create("EditBox");
	startDate:SetLabel("Start Date");
	startDate:SetWidth(100);
	startDate:SetCallback("OnEnterPressed", function(widget, event, text)
		if(self:CheckDateString(text) == false) then
			GameTooltip:SetOwner(startDate.frame,"ANCHOR_RIGHT");
			GameTooltip:AddLine("Wrong Date Format");
			GameTooltip:Show();
		else
			GameTooltip:Hide();
			startDateText = text;
			MorthalinRaidTools:LoadStatistics();
			self:UpdateStatisticsView(sortType);
		end
	end);
	controlsHeader:AddChild(startDate);
	
	stopDate = AceGUI:Create("EditBox");
	stopDate:SetLabel("Stop Date");
	stopDate:SetWidth(100);
	stopDate:SetCallback("OnEnterPressed", function(widget, event, text) 
		if(self:CheckDateString(text) == false) then 
			GameTooltip:SetOwner(stopDate.frame,"ANCHOR_RIGHT");
			GameTooltip:AddLine("Wrong Date Format");
			GameTooltip:Show();
		else
			GameTooltip:Hide();
			stopDateText = text;
			MorthalinRaidTools:LoadStatistics();
			self:UpdateStatisticsView(sortType);
		end
	end);
	controlsHeader:AddChild(stopDate);
	
	-- TABLE HEADER
	local tableHeader = AceGUI:Create("SimpleGroup");
	tableHeader:SetFullWidth(true);
	tableHeader:SetLayout("Flow");
	self.ui.statisticsFrame:AddChild(tableHeader);

	local historyBtn = AceGUI:Create("InteractiveLabel");
	historyBtn:SetWidth(150);
	historyBtn:SetText("Player");
	historyBtn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5)
	historyBtn:SetCallback("OnClick", function() sortType = 0; self:UpdateStatisticsView(sortType); end);
	tableHeader:AddChild(historyBtn);
	
	historyBtn = AceGUI:Create("InteractiveLabel");
	historyBtn:SetWidth(75);
	historyBtn:SetText("Overall");
	historyBtn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5)
	historyBtn:SetCallback("OnClick", function() sortType = 1; self:UpdateStatisticsView(sortType); end);
	tableHeader:AddChild(historyBtn);
	
	historyBtn = AceGUI:Create("InteractiveLabel");
	historyBtn:SetWidth(75);
	historyBtn:SetText("Main Raids");
	historyBtn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5)
	historyBtn:SetCallback("OnClick", function() sortType = 2; self:UpdateStatisticsView(sortType); end);
	tableHeader:AddChild(historyBtn);
	
	historyBtn = AceGUI:Create("InteractiveLabel");
	historyBtn:SetWidth(75);
	historyBtn:SetText("Optional");
	historyBtn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5)
	historyBtn:SetCallback("OnClick", function() sortType = 3; self:UpdateStatisticsView(sortType); end);
	tableHeader:AddChild(historyBtn);
	
	item1Btn = AceGUI:Create("InteractiveLabel");
	item1Btn:SetWidth(100);
	item1Btn:SetText("raid1");
	tableHeader:AddChild(item1Btn);
	
	item2Btn = AceGUI:Create("InteractiveLabel");
	item2Btn:SetWidth(100);
	item2Btn:SetText("raid2");
	tableHeader:AddChild(item2Btn);
	
	item3Btn = AceGUI:Create("InteractiveLabel");
	item3Btn:SetWidth(100);
	item3Btn:SetText("raid3");
	tableHeader:AddChild(item3Btn);
	
	item4Btn = AceGUI:Create("InteractiveLabel");
	item4Btn:SetWidth(100);
	item4Btn:SetText("raid4");
	tableHeader:AddChild(item4Btn);
	
	item5Btn = AceGUI:Create("InteractiveLabel");
	item5Btn:SetWidth(100);
	item5Btn:SetText("raid5");
	tableHeader:AddChild(item5Btn);
	
	item6Btn = AceGUI:Create("InteractiveLabel");
	item6Btn:SetWidth(100);
	item6Btn:SetText("raid6");
	tableHeader:AddChild(item6Btn);
	
	item7Btn = AceGUI:Create("InteractiveLabel");
	item7Btn:SetWidth(100);
	item7Btn:SetText("raid7");
	tableHeader:AddChild(item7Btn);
	
	--TABLE DATA PART
	scrollcontainer = AceGUI:Create("SimpleGroup");
	scrollcontainer:SetFullWidth(true);
	scrollcontainer:SetHeight(360);
	scrollcontainer:SetLayout("Fill");
	self.ui.statisticsFrame:AddChild(scrollcontainer);
	scrollcontainer:ClearAllPoints();
	scrollcontainer.frame:SetPoint("TOP", tableHeader.frame, "BOTTOM", 0, -5);
	scrollcontainer.frame:SetPoint("BOTTOM", 0, 20);

	scrollStatistics = CreateFrame("ScrollFrame", nil, scrollcontainer.frame, "myScrollFrame");
	HybridScrollFrame_CreateButtons(scrollStatistics, "statisticsListItemTemplate");
	HybridScrollFrame_SetDoNotHideScrollBar(scrollStatistics, true);
	
	scrollStatistics.update = function() 
		self:UpdateStatisticsView(sortType);
	end
	self.ui.statisticsFrame:Hide();
	MorthalinRaidTools:LoadRaidHeaders();
end

function MorthalinRaidTools:CheckDateString(text)
	local day, month, year = text:match('^(%d+).(%d+).(%d+)$');
	
	if(day == nil or month == nil  or year == nil) then
		return false;
	end
	
	if(string.len(day) ~= 2) then
		day = "0" .. day;
	end
	if(string.len(month) ~= 2) then
		month = "0" .. month;
	end
	text = day .. "." .. month .. "." .. year;
	local dateInt = time{year=year, month=month, day=day};
	return text == date("%d.%m.%Y", dateInt);
end

function MorthalinRaidTools:LoadRaidHeaders()
	if(MorthalinRaidTools.db.global.statRaids[firstIndex] ~= nil) then
		item1Btn.frame:Show();
		item1Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item1Btn:SetCallback("OnClick", function() sortType = 4; self:UpdateStatisticsView(sortType); end);
		item1Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex].zone);
	else
		item1Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item1Btn:SetCallback("OnClick", nil);
		item1Btn:SetText("");
		item1Btn.frame:Hide();
	end
	if(MorthalinRaidTools.db.global.statRaids[firstIndex + 1] ~= nil) then
		item2Btn.frame:Show();
		item2Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item2Btn:SetCallback("OnClick", function() sortType = 5; self:UpdateStatisticsView(sortType); end);
		item2Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex + 1].zone);
	else
		item2Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item2Btn:SetCallback("OnClick", nil);
		item2Btn:SetText("");
		item2Btn.frame:Hide();
	end
	if(MorthalinRaidTools.db.global.statRaids[firstIndex + 2] ~= nil) then
		item3Btn.frame:Show();
		item3Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item3Btn:SetCallback("OnClick", function() sortType = 6; self:UpdateStatisticsView(sortType); end);
		item3Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex + 2].zone);
	else
		item3Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item3Btn:SetCallback("OnClick", nil);
		item3Btn:SetText("");
		item3Btn.frame:Hide();
	end
	if(MorthalinRaidTools.db.global.statRaids[firstIndex + 3] ~= nil) then
		item4Btn.frame:Show();
		item4Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item4Btn:SetCallback("OnClick", function() sortType = 7; self:UpdateStatisticsView(sortType); end);
		item4Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex + 3].zone);
	else
		item4Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item4Btn:SetCallback("OnClick", nil);
		item4Btn:SetText("");
		item4Btn.frame:Hide();
	end
	if(MorthalinRaidTools.db.global.statRaids[firstIndex + 4] ~= nil) then
		item5Btn.frame:Show();
		item5Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item5Btn:SetCallback("OnClick", function() sortType = 8; self:UpdateStatisticsView(sortType); end);
		item5Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex + 4].zone);
	else
		item5Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item5Btn:SetCallback("OnClick", nil);
		item5Btn:SetText("");
		item5Btn.frame:Hide();
	end
	if(MorthalinRaidTools.db.global.statRaids[firstIndex + 5] ~= nil) then
		item6Btn.frame:Show();
		item6Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item6Btn:SetCallback("OnClick", function() sortType = 9; self:UpdateStatisticsView(sortType); end);
		item6Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex + 5].zone);
	else
		item6Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item6Btn:SetCallback("OnClick", nil);
		item6Btn:SetText("");
		item6Btn.frame:Hide();
	end
	if(MorthalinRaidTools.db.global.statRaids[firstIndex + 6] ~= nil) then
		item7Btn.frame:Show();
		item7Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5);
		item7Btn:SetCallback("OnClick", function() sortType = 10; self:UpdateStatisticsView(sortType); end);
		item7Btn:SetText(MorthalinRaidTools.db.global.statRaids[firstIndex + 6].zone);
	else
		item7Btn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0);
		item7Btn:SetCallback("OnClick", nil);
		item7Btn:SetText("");
		item7Btn.frame:Hide();
	end
end

function MorthalinRaidTools:LoadStatistics()
	statisticsPlayerData = {};
	killsCounts = {};
	killsCounts["all"] = 0;
	killsCounts["main"] = 0;
	killsCounts["opt"] = 0;
	wipeCounts = {};
	wipeCounts["all"] = 0;
	wipeCounts["main"] = 0;
	wipeCounts["opt"] = 0;
	local minDate = -1;
	local maxDate = -1;
	local dayA, monthA, yearA = 0,0,0;
	if(string.len(startDateText) ~= 0) then
		dayA, monthA, yearA = startDateText:match('(%d+).(%d+).(%d+)');
	end
	local dateStartInt = 0;
	if(string.len(startDateText) ~= 0 and MorthalinRaidTools:CheckDateString(startDateText)) then
		dateStartInt = time{year=yearA, month=monthA, day=dayA};
	end
	local dayB, monthB, yearB = 0,0,0;
	if(string.len(stopDateText) ~= 0) then
		dayB, monthB, yearB = stopDateText:match('(%d+).(%d+).(%d+)');
	end
	local dateStopInt = GetServerTime();
	if(string.len(stopDateText) ~= 0 and MorthalinRaidTools:CheckDateString(stopDateText)) then
		dateStopInt = time{year=yearB, month=monthB, day=dayB};
	end
	
	local uniqueHistory = {};
	for i = 1, #self.db.global.history do
		if(dateStartInt <= self.db.global.history[i].killDate and dateStopInt >= self.db.global.history[i].killDate) then
			if(uniqueHistory[self.db.global.history[i].zone] == nil) then
				uniqueHistory[self.db.global.history[i].zone] = {resets = {}};
			end
			if(uniqueHistory[self.db.global.history[i].zone].resets[self.db.global.history[i].resetDate] == nil) then
				uniqueHistory[self.db.global.history[i].zone].resets[self.db.global.history[i].resetDate] = {bosses = {}};
			end
			if(uniqueHistory[self.db.global.history[i].zone].resets[self.db.global.history[i].resetDate].bosses[self.db.global.history[i].bossID] == nil) then
				uniqueHistory[self.db.global.history[i].zone].resets[self.db.global.history[i].resetDate].bosses[self.db.global.history[i].bossID] = true;
				
				if(self.db.global.history[i].wipe == false) then
					if(killsCounts[self.db.global.history[i].zone] == nil) then
						killsCounts[self.db.global.history[i].zone] = 1;
					else
						killsCounts[self.db.global.history[i].zone] = killsCounts[self.db.global.history[i].zone] + 1;
					end
					killsCounts["all"] = killsCounts["all"] + 1;
					
					local found = false;
					for j = 1, #MorthalinRaidTools.db.global.mainRaids do
						if(MorthalinRaidTools.db.global.mainRaids[j].value and MorthalinRaidTools.db.global.mainRaids[j].zone == self.db.global.history[i].zone) then
							if(killsCounts["main"] == nil) then
								killsCounts["main"] = 1;
							else
								killsCounts["main"] = killsCounts["main"] + 1;
							end	
							found = true;
						end
					end
					if(found == false) then
						if(killsCounts["opt"] == nil) then
							killsCounts["opt"] = 1;
						else
							killsCounts["opt"] = killsCounts["opt"] + 1;
						end	
					end
				else
					if(wipeCounts[self.db.global.history[i].zone] == nil) then
						wipeCounts[self.db.global.history[i].zone] = 1;
					else
						wipeCounts[self.db.global.history[i].zone] = wipeCounts[self.db.global.history[i].zone] + 1;
					end
					wipeCounts["all"] = wipeCounts["all"] + 1;
					
					local found = false;
					for j = 1, #MorthalinRaidTools.db.global.mainRaids do
						if(MorthalinRaidTools.db.global.mainRaids[j].value and MorthalinRaidTools.db.global.mainRaids[j].zone == self.db.global.history[i].zone) then
							if(wipeCounts["main"] == nil) then
								wipeCounts["main"] = 1;
							else
								wipeCounts["main"] = wipeCounts["main"] + 1;
							end	
							found = true;
						end
					end
					if(found == false) then
						if(wipeCounts["opt"] == nil) then
							wipeCounts["opt"] = 1;
						else
							wipeCounts["opt"] = wipeCounts["opt"] + 1;
						end	
					end
				end
			end
			if(minDate == -1 or minDate > self.db.global.history[i].killDate) then
				minDate = self.db.global.history[i].killDate;
			end
			if(maxDate == -1 or maxDate < self.db.global.history[i].killDate) then
				maxDate = self.db.global.history[i].killDate;
			end
		end
	end
	
	if(string.len(startDate:GetText()) == 0) then
		startDate:SetText(date("%d.%m.%Y", minDate));
	end
	if(string.len(stopDate:GetText()) == 0) then
		stopDate:SetText(date("%d.%m.%Y", maxDate));
	end
	
	for i=1, GetNumGuildMembers() do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
		if(string.sub(officernote, 1, 4) == "Alt:") then
			if(alts[string.sub(name, 1, name:find("-") - 1)] == nil) then
				alts[string.sub(name, 1, name:find("-") - 1)] = string.sub(officernote, 5, -1);
			end
		end
	end
	
	local playerStatistics = {};
	for i = 1, #self.db.global.history do
		if(dateStartInt <= self.db.global.history[i].killDate and dateStopInt >= self.db.global.history[i].killDate) then
			for j = 1, #self.db.global.history[i].members do
				local tempName = {};
				if(alts[self.db.global.history[i].members[j].name] ~= nil) then
					tempName = alts[self.db.global.history[i].members[j].name];
				else
					tempName = self.db.global.history[i].members[j].name;
				end
				
				if(playerStatistics[tempName] == nil) then
					local playerStatisticsTemp = 
					{
						class = {},
						color = {},
						boss = {}
					}
					playerStatistics[tempName] = playerStatisticsTemp;
					if(alts[self.db.global.history[i].members[j].name] == nil) then
						playerStatistics[tempName].class = self.db.global.history[i].members[j].class;
						playerStatistics[tempName].color = self.db.global.history[i].members[j].color;
					else
						for i=1, GetNumGuildMembers() do
							local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
							if(tempName == string.sub(name, 1, name:find("-") - 1)) then
								playerStatistics[tempName].class = class;
								playerStatistics[tempName].color = MorthalinRaidTools.classColors[class].hex;
							end
						end
					end
				end
				if(playerStatistics[tempName].boss[self.db.global.history[i].bossID] == nil) then
					local boss = {
						count = 1,
						name = self.db.global.history[i].bossName,
						zone = self.db.global.history[i].zone,
						dates = {}
					}
					playerStatistics[tempName].boss[self.db.global.history[i].bossID] = boss;
					playerStatistics[tempName].boss[self.db.global.history[i].bossID].dates[self.db.global.history[i].resetDate] = self.db.global.history[i].killDate;
				else
					if(playerStatistics[tempName].boss[self.db.global.history[i].bossID].dates[self.db.global.history[i].resetDate] == nil) then
						playerStatistics[tempName].boss[self.db.global.history[i].bossID].count = playerStatistics[tempName].boss[self.db.global.history[i].bossID].count + 1;
						playerStatistics[tempName].boss[self.db.global.history[i].bossID].dates[self.db.global.history[i].resetDate] = self.db.global.history[i].killDate;
					elseif(alts[self.db.global.history[i].members[j].name] ~= nil) then
						playerStatistics[tempName].boss[self.db.global.history[i].bossID].dates[self.db.global.history[i].resetDate] = self.db.global.history[i].killDate;
					end
				end
			end
		end
	end
	
	for index, player in pairs(playerStatistics) do
		local data = {
			name = index,
			class = player.class,
			color = player.color,
			count = 0,
			countMain = 0,
			countOpt = 0,
			boss = {},
			instances = {}
		}
		
		for id, bossData in pairs(player.boss) do
			local tempBossData = {
				encounterID = id,
				name = bossData.name,
				zone = bossData.zone,
				count = bossData.count
			}
			
			table.insert(data.boss, tempBossData);
			if(data.instances[bossData.zone] == nil) then
				data.instances[bossData.zone] = bossData.count;
			else
				data.instances[bossData.zone] = data.instances[bossData.zone] + bossData.count;
			end
			data.count = data.count + bossData.count;
			local found = false;
			for j = 1, #MorthalinRaidTools.db.global.mainRaids do
				if(MorthalinRaidTools.db.global.mainRaids[j].value and MorthalinRaidTools.db.global.mainRaids[j].zone == bossData.zone) then
					data.countMain = data.countMain + bossData.count;
					found = true;
				end
			end
			if(found == false) then
				data.countOpt = data.countOpt + bossData.count;
			end
		end
		local function sortBosses(a, b)
			if(a.zone == b.zone) then
				return a.name < b.name;
			else
				return a.zone < b.zone;
			end
		end
		table.sort(data.boss, sortBosses);
		table.insert(statisticsPlayerData, data);
	end
	
	local indexes = {};
	for i = 1, #statisticsPlayerData do
		if(statisticsPlayerData[(#statisticsPlayerData + 1 - i)].count == 0) then
			playerStatistics[statisticsPlayerData[(#statisticsPlayerData + 1 - i)].name] = nil;
			table.insert(indexes, (#statisticsPlayerData + 1 - i));
		end
	end
	
	for i = 1, #indexes do
		table.remove(statisticsPlayerData, indexes[i]);
	end
end

function MorthalinRaidTools:UpdateStatisticsView(sort)
	if(sort == nil) then
		sort = sortType;
	end
	local buttons = HybridScrollFrame_GetButtons(scrollStatistics);
	local offset = HybridScrollFrame_GetOffset(scrollStatistics);
	
	local function sortPlayers(a, b)
		if(sort == 0) then
			return a.name < b.name;
		elseif(sort == 1) then
			if(a.count == b.count) then
				return a.name < b.name;
			else
				return a.count > b.count;
			end
		elseif(sort == 2) then
			if(a.countMain == b.countMain) then
				return a.name < b.name;
			else
				return a.countMain > b.countMain;
			end
		elseif(sort == 3) then
			if(a.countOpt == b.countOpt) then
				return a.name < b.name;
			else
				return a.countOpt > b.countOpt;
			end
		elseif(sort > 3) then
			if((a.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone] == nil and 0 or a.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone]) == (b.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone] == nil and 0 or b.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone])) then
				return a.name < b.name;
			else
				return (a.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone] == nil and 0 or a.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone]) > (b.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone] == nil and 0 or b.instances[MorthalinRaidTools.db.global.statRaids[sort - 3].zone])
			end
		end
	end
	table.sort(statisticsPlayerData, sortPlayers);
	
	
	for buttonIndex = 1, #buttons do
		local button = buttons[buttonIndex];
		local itemIndex = buttonIndex + offset;
		
		if (itemIndex <= #statisticsPlayerData) then
			button:SetID(itemIndex);
			button.Player:SetText("|cff" .. (type(statisticsPlayerData[itemIndex].color) == "string" and statisticsPlayerData[itemIndex].color or "ff0000") .. statisticsPlayerData[itemIndex].name);
			button:SetScript('OnEnter', function() self:ShowAlts(button, statisticsPlayerData[itemIndex].name, alts) end);
			button:SetScript('OnLeave', function() self:HideTooltip() end);
			button.Overall:SetText(self:GetPercentageWithColor(statisticsPlayerData[itemIndex].count, killsCounts["all"]));
			button.MainRaids:SetText(self:GetPercentageWithColor(statisticsPlayerData[itemIndex].countMain, killsCounts["main"]));
			button.OptRaids:SetText(self:GetPercentageWithColor(statisticsPlayerData[itemIndex].countOpt, killsCounts["opt"]));
			if(MorthalinRaidTools.db.global.statRaids[firstIndex] ~= nil) then
				button.raid1:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex].zone], 0) .. "%"));
			else
				button.raid1:SetText("");
			end
			if(MorthalinRaidTools.db.global.statRaids[firstIndex + 1] ~= nil) then
				button.raid2:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 1].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 1].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 1].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 1].zone], 0) .. "%"));
			else
				button.raid2:SetText("");
			end
			if(MorthalinRaidTools.db.global.statRaids[firstIndex + 2] ~= nil) then
				button.raid3:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 2].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 2].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 2].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 2].zone], 0) .. "%"));
			else
				button.raid3:SetText("");
			end
			if(MorthalinRaidTools.db.global.statRaids[firstIndex + 3] ~= nil) then
				button.raid4:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 3].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 3].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 3].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 3].zone], 0) .. "%"));
			else
				button.raid4:SetText("");
			end
			if(MorthalinRaidTools.db.global.statRaids[firstIndex + 4] ~= nil) then
				button.raid5:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 4].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 4].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 4].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 4].zone], 0) .. "%"));
			else
				button.raid5:SetText("");
			end
			if(MorthalinRaidTools.db.global.statRaids[firstIndex + 5] ~= nil) then
				button.raid6:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 5].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 5].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 5].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 5].zone], 0) .. "%"));
			else
				button.raid6:SetText("");
			end
			if(MorthalinRaidTools.db.global.statRaids[firstIndex + 6] ~= nil) then
				button.raid7:SetText((killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 6].zone] == 0 and "No kills" or self:Round((statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 6].zone] == nil and 0 or statisticsPlayerData[itemIndex].instances[MorthalinRaidTools.db.global.statRaids[firstIndex + 6].zone]) * 100 / killsCounts[MorthalinRaidTools.db.global.statRaids[firstIndex + 6].zone], 0) .. "%"));
			else
				button.raid7:SetText("");
			end
			button:RegisterForClicks("MiddleButtonUp");
			button:SetScript('OnClick', function(self, button, down) if(button == "MiddleButton") then MorthalinRaidTools:DeletePlayerHistory(statisticsPlayerData[itemIndex]) end end)
			button:Show();
		else
			button:Hide();
		end
	end

	local buttonHeight = scrollStatistics.buttonHeight;
	local totalHeight = #statisticsPlayerData * buttonHeight;
	local shownHeight = #buttons * buttonHeight;

	HybridScrollFrame_Update(scrollStatistics, totalHeight, shownHeight);
end

function MorthalinRaidTools:ShowAlts(obj, name, altTable)
	GameTooltip:SetOwner(obj,"ANCHOR_LEFT");
	GameTooltip:AddLine("Alts:");
	for alt, main in pairs(altTable) do
		if(main == name) then
			GameTooltip:AddLine(alt);
		end
	end
	GameTooltip:Show();
end

function MorthalinRaidTools:DeletePlayerHistory(player)
	playerForRemove = player;
	self:ConstructConfirm("Confirmation", "Removing |cff" .. playerForRemove.color .. playerForRemove.name .. "|r from history", "Player: " .. playerForRemove.name, 8);
end

function MorthalinRaidTools:DeletePlayerComfirmed()
	for i = 1, #self.db.global.history do 
	local count = #self.db.global.history[i].members;
		for j = 1, count do
			if(self.db.global.history[i].members[(count + 1 - j)].name == playerForRemove.name or alts[self.db.global.history[i].members[(count + 1 - j)].name] == playerForRemove.name) then
				table.remove(self.db.global.history[i].members, (count + 1 - j));
			end
		end
	end
	MorthalinRaidTools:LoadStatistics();
	MorthalinRaidTools:UpdateStatisticsView();
	MorthalinRaidTools:UpdateHistory();
end
